#include "simulation.h"
 
void simulation::run(unsigned int cTime)
{
   while( !eventQueue.empty()) // D揇ʃL[ɓo^ꂽCxgXL
   {
      event * nextEvent = eventQueue.top();
      time=nextEvent->time;
      time >>= 16;              // ()ŏꂽ time ʏ time ɖ߂

      if( time >= cTime )  break;   // while 𔲂o

       nextEvent->time = time;     // ʏ time ɖ߂Ă
       nextEvent->processEvent();  // processEvent s

       // ̃Cxgo (|bv)
       eventQueue.pop();
       delete nextEvent;
   }
}

void simulation::scheduleEvent (event * newEvent){

  // Cxg𐳂s邽߂̏ ()
  unsigned int time_ = newEvent->time;
  time_ <<= 16;
  time_ |= ++eventID;
  newEvent->time = time_;

  newEvent->SimObj = SimObj;

  // CxgD揇ʃL[֓o^	
  eventQueue.push ( newEvent);
}

void simulation::deliver(unsigned int time, Node* NodeObj )
{
  edgeMap::iterator eitr;   // SĂ Edge XL邽߂̃Ce[^
  for ( eitr  = NodeObj->outPin[0]->edge.begin();
        eitr != NodeObj->outPin[0]->edge.end  (); eitr++ )
  {
     Node* dnode  = eitr->second->dstNode ;    // Cxg̓` Node
     if(dnode != 0)    // ` Node ݂
         scheduleEvent(new execEvent(time+1, NodeObj->out, eitr->second->dstPin, dnode));  // VɔCxgo^
  }
}

void execEvent::processEvent(){

  NodeObj->exec(time, svalue, pin );

}

void deliverEvent::processEvent(){

   SimObj->deliver(time, NodeObj);
   NodeObj->requestRun = false;

}
